/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
/*******************************************************************************
 *  generated by script                                                        *
 *******************************************************************************/

#ifndef X3DTK_KERNEL_H
#define X3DTK_KERNEL_H

//abstractNode
#include "private/CreationFunction.h"
#include "private/SFComponent.h"
#include "private/SFSceneGraph.h"
#include "private/SFType.h"
#include "private/X3DAbstractNode.h"
#include "private/X3DAttributeRecorder.h"
#include "private/X3DField.h"
#include "private/X3DMemberFunctor.h"
#include "private/X3DMFNodeFunctor.h"
#include "private/X3DMFNodeRecorder.h"
#include "private/X3DRoute.h"
#include "private/X3DSFNodeFunctor.h"
#include "private/X3DSFNodeRecorder.h"

//base
#include "private/BaseRecorder.h"
#include "private/BBox.h"
#include "private/CLog.h"
#include "private/Platform.h"
#include "private/Recorder.h"
#include "private/SFMatrix34f.h"
#include "private/SFPoint2f.h"
#include "private/SFPoint3f.h"
#include "private/SFString.h"
#include "private/SFVec2f.h"
#include "private/SFVec3f.h"
#include "private/Signal.h"
#include "private/TypeList.h"
#include "private/X3DBaseTypes.h"
#include "private/X3DFileElement.h"
#include "private/X3DNodeCloner.h"
#include "private/X3DTypes.h"

//image
#include "private/Image.h"
#include "private/JPGImageType.h"

//processor
#include "private/AbstractVisitor.h"
#include "private/DFSGraphTraversal.h"
#include "private/DFSWalker.h"
#include "private/EnterFunction.h"
#include "private/GraphTraversal.h"
#include "private/LeaveFunction.h"
#include "private/NodeFactory.h"
#include "private/ProcessHistory.h"
#include "private/Progress.h"
#include "private/Singleton.h"
#include "private/StateVariables.h"
#include "private/VisitingFunctions.h"
#include "private/Visitor.h"
#include "private/Walker.h"
#include "private/WalkOnFunction.h"
#include "private/X3DActor.h"
#include "private/X3DComponent.h"
#include "private/X3DComponentVisitor.h"
#include "private/X3DFunction.h"
#include "private/X3DMultiPassProcessor.h"
#include "private/X3DOnePassProcessor.h"
#include "private/X3DProcessor.h"

#endif
