/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_GL_RENDERERSHAPEVISITOR_H
#define X3DTK_GL_RENDERERSHAPEVISITOR_H

#include "GL_ShapeVisitor.h"
#include "GL_RendererStateVariables.h"

namespace X3DTK {
namespace GL {

class Material;
class X3DShapeNode;

/*! \brief Class declared in <b><X3DTK/GL/renderer.h></b> providing a visitor for 
 *  the Shape component of the GL::Renderer processor.
 *
 *  \ingroup GL
 */

class RendererShapeVisitor : public ShapeVisitor
{
public:
  /// Constructor.
  RendererShapeVisitor();

  /// Enters a Material.
  static void enterMaterial(Material *M);
  /// Enters an X3DShapeNode.
  static void enterX3DShapeNode(X3DShapeNode *N);
};

}
}

#endif
