/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_MESH_CONNECTEDCOMCOMPUTERCOREVISITOR_H
#define X3DTK_MESH_CONNECTEDCOMCOMPUTERCOREVISITOR_H

#include "MESH_ConnectedComComputerStateVariables.h"
#include "MESH_CoreVisitor.h"
#include "MESH_Mesh.h"
#include "MESH_Shape.h"
#include "MESH_X3DGroupingNode.h"
#include "MESH_Vertex.h"
#include "MESH_SceneGraphTypes.h"
#include "MemReleaser.h"

#include <map>

namespace X3DTK {
namespace MESH {

/*! \brief Class declared in <b><X3DTK/MESH/connectedcomcomputer.h></b> providing a visitor of the 
 *  Core component of the MESH::ConnectedComComputer processor.
 *
 *  \ingroup MESH
 */

class ConnectedComComputerCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  ConnectedComComputerCoreVisitor(Progress *progress);

  /// Enters a Vertex.
  static void enterVertex(Vertex *V);
  /// Walks on a Shape.
  static bool walkOnShape(Shape *S, SFNode child);
};

}
}

#endif
