/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_MESH_X3DMESHNODE_H
#define X3DTK_MESH_X3DMESHNODE_H

#include "MESH_SceneGraphTypes.h"
#include "MESH_X3DVertexNode.h"

namespace X3DTK {
namespace MESH {

/*! \brief Base class declared in <b><X3DTK/MESH/scenegraph.h></b> defining a non-template
 *  interface for the template Mesh node of the MESH scene graph.
 *
 *  \ingroup MeshSceneGraph
 */

class X3DMeshNode : public X3DNode
{
public:
  /// Constructor.
  X3DMeshNode();
  /// Virtual destructor.
  virtual ~X3DMeshNode();
  
  /// Gets the VertexSet.
  inline X3DVertexNode *getVertex() const {return vertex;};
  
protected:
  /// VertexSet.
  X3DVertexNode *vertex;
};

}
}

#endif
