/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DMEMBERFUNCTOR_H
#define X3DMEMBERFUNCTOR_H

#include "X3DField.h"

namespace X3DTK {

class X3DAbstractNode;

class X3DMemberFunctor
{
public:
  virtual X3DField getValueOf(X3DAbstractNode const *N) const = 0;
  virtual void setValueOf(X3DAbstractNode *N, const X3DField &field) = 0;
};

template<class T, class V>
class MemberFunctor : public X3DMemberFunctor
{
public:
  MemberFunctor(V T:: *member);
  
  X3DField getValueOf(X3DAbstractNode const *N) const;
  void setValueOf(X3DAbstractNode *N, const X3DField &field);
 
private:
  V T:: *_member;
};

}

#include "X3DMemberFunctor.inl"

#endif
