/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_MESH_PRIMITIVEMESHBUILDERGEOMETRY3DVISITOR_H
#define X3DTK_MESH_PRIMITIVEMESHBUILDERGEOMETRY3DVISITOR_H

#include "X3D_Geometry3DVisitor.h"

namespace X3DTK {
namespace X3D {

class Box;
class Cylinder;
class Cone;
class Sphere;

/*! \brief Class declared in <b><X3DTK/MESH/primitivemeshbuilder.h></b> providing a visitor of the 
 *  Geometry3D component of the PrimitiveMeshBuilder processor.
 *
 *  \ingroup MESH
 */

class PrimitiveMeshBuilderGeometry3DVisitor : public Geometry3DVisitor
{
public:
  /// Constructor.
  PrimitiveMeshBuilderGeometry3DVisitor();

  /// Enters a Box.
  static void enterBox(Box *B); 
  /// Enters a Cylinder.
  static void enterCylinder(Cylinder *C);
  /// Enters a Cone.
  static void enterCone(Cone *C);
  /// Enters a Sphere.
  static void enterSphere(Sphere *S);
};

}
}

#endif
