/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_QLOADER_H
#define X3DTK_QLOADER_H

#include "X3D_X3DXmlLoader.h"

namespace X3DTK {
namespace X3D {

class Creator;
class QLoaderImplementation;

/*! \brief Class declared in <b><X3DTK/X3D/scenegraph.h></b> defining an Xml SAX2 
 *  loader for X3D based upon the Qt library.
 *  
 *  \ingroup X3DLoader
 */

class QLoader : public X3DXmlLoader
{
public:
  /// Constructor.
  QLoader(Creator *creator);
  /// Destructor.
  ~QLoader();

  /// Loads a scene from the file.
  X3D::Scene *load(const char *file, bool fileValidation) const;
  
private:
  QLoaderImplementation *_impl;
};

}
}

#endif
