#include "GL_NormalRendererGroupingVisitor.h"

namespace X3DTK {
namespace GL {

NormalRendererGroupingVisitor::NormalRendererGroupingVisitor()
: GroupingVisitor()
{
  // Enter functions.
  define(Recorder<Transform>::getEnterFunction(&NormalRendererGroupingVisitor::enterTransform));
  // Leave functions
  define(Recorder<Transform>::getLeaveFunction(&NormalRendererGroupingVisitor::leaveTransform));
}

void NormalRendererGroupingVisitor::enterTransform(Transform *T)
{
  // Changing the coordinates system.
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glMultMatrixf(&T->getTransformMatrix().front());
}

void NormalRendererGroupingVisitor::leaveTransform(Transform *)
{
  // Returning to the old coordinates system.
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();  
}

}
}
