#ifndef VIEWER_H
#define VIEWER_H

#include "NormalX3DGLScene.h"

#include <QGLViewer/qglviewer.h>

/// Class providing a Viewer implementing QGLViewer.

class Viewer : public QGLViewer
{
public:
  Viewer(const char *file);
  ~Viewer();
  
protected :
  void loadFile();
  void keyPressEvent(QKeyEvent *e);
  void init();
  void draw();
  void about();
  QString helpString() const;
  void help() const;
  
private:
  float normLength;
  X3DTK::NormalX3DGLScene scene;
  X3DTK::BBox BB;
  char *x3dfile;
  bool normal;
};

#endif
