#include <X3DTK/X3D/scenegraph.h>
#include <X3DTK/graphtester.h>
#include <X3DTK/memreleaser.h>
#include <iostream>

using namespace X3DTK;
using namespace std;

int main(int argc, char *argv[])
{ 
  if (argc <= 1)
  {
    cerr << "usage: graphtester input" << endl;
    exit(0);
  }
  
  // Default loader for the X3D Nodes.
  X3D::Loader loader;
  // Instanciation of X3DTK::GraphTester.
  GraphTester tester;
  // Instanciation of X3DTK::MemReleaser.
  MemReleaser releaser;
  
  // Loads the scene.
  X3D::Scene *s = loader.load(argv[1]);
  // Tests the scene graph.
  tester.test(s);
  // Releases the scene graph.
  releaser.release(s);
  
  return 1;
}
