#ifndef GL_ICOSAHEDRON_H
#define GL_ICOSAHEDRON_H

#include <X3DTK/GL/scenegraph.h>

namespace X3DTK {
namespace GL {

// Class providing an implementation of the GL node corresponding to  
// X3D::Icosahedron.

class Icosahedron : public X3DGeometryNode
{
public:
  Icosahedron();
  virtual ~Icosahedron();

  void setRadius(const SFFloat &radius);
  inline const SFFloat &getRadius() const {return _radius;};

  virtual void update();
  virtual void draw() const;

private:  
  MFVec3f _vertices;
  short _indexes[12][5];
  MFVec3f _normal;
  SFFloat _radius; 
};

}
}

#endif
