#include "Date.h"
#include <iostream>

using namespace std;

namespace X3DTK {

Date::Date()
: day(0), month(0), year(0)
{
}

Date::Date(const SFString &date)
{
  SFString d, m, y;
  
  m = date.substr(0, 2);
  d = date.substr(3, 2);
  y = date.substr(6, 2);

  day = d.toInt();
  month = m.toInt();
  year = y.toInt();
}

SFString Date::toSFString() const
{
  SFString m = SFString::number(month);
  SFString d = SFString::number(day);
  SFString y = SFString::number(year);
  
  if (m.size() == 1)
    m = '0' + m;
  if (d.size() == 1)
    d = '0' + d;
  if (y.size() == 1)
    y = '0' + y;
  
  return "\"" + m + "/" + d + "/" + y + "\"";
}

std::ostream& X3DTK::operator<<(std::ostream& o, const Date &date)
{
  return o << date.month << "/" << date.day << "/" << date.year;
}

}
