#include "X3D_Info.h"
#include "X3D_Price.h"
#include "X3D_Modeler.h"

namespace X3DTK {
namespace X3D {

Info::Info()
: X3DChildNode()
{
  // Defines the tag of the node. This string is the one read in the X3D file.
  define(Recorder<Info>::getTypeName("Info"));
  
  // Defines an attribute.
  define(Recorder<Info, Date>::getAttribute("date", &Info::_date, Date()));
  
  // Defines a child node.
  define(Recorder<Info, Price>::getSFNode("price", &Info::_price));
  define(Recorder<Info, Modeler>::getSFNode("modeler", &Info::_modeler));
}

Info::~Info()
{
  removeChidlren();
}

void Info::setDate(const Date &date)
{
  _date = date;
}

}
}
