#include "X3D_Price.h"

namespace X3DTK {
namespace X3D {

Price::Price()
: X3DChildNode()
{
  // Defines the tag of the node. This string is the one read in the X3D file.
  define(Recorder<Price>::getTypeName("Price"));
  
  // Defines the attributes.
  define(Recorder<Price, SFFloat>::getAttribute("price", &Price::_price, 0.0f));
  define(Recorder<Price, SFString>::getAttribute("money", &Price::_money, "euro"));
}

Price::~Price()
{
}

void Price::setPrice(const SFFloat &price)
{
  _price = price;
}

void Price::setMoney(const SFString &money)
{
  _money = money;
}

}
}
