#include "X3D_InfoReader.h"
#include "X3D_MyGroupingCreator.h"

#include <X3DTK/X3D/scenegraph.h>
#include <X3DTK/X3D/scenesaver.h>
#include <iostream>

using namespace X3DTK;
using namespace std;

int main(int argc, char *argv[])
{
  if (argc <= 1)
  {
    cerr << "usage: infoReader input" << endl;
    exit(0);
  }
  
  // DefaultLoader to load the default X3D Nodes.
  X3D::Loader *loader = Singleton<X3D::Loader>::getInstance();
  loader->setComponentCreator(new X3D::MyGroupingCreator());
  
  // Instanciation of the new InfoReader.
  X3D::InfoReader *infoReader = Singleton<X3D::InfoReader>::getInstance();

  /// Instanciation of the SceneSaver.
  X3D::SceneSaver *saver = Singleton<X3D::SceneSaver>::getInstance();
  
  // Loads the scene.
  X3D::Scene *s = loader->load(argv[1], false);
  // reads the graph.
  infoReader->read(s);
  /// saves the graph.
  saver->saveAs(s, "myfile.x3d");
  
  // Removes the instances.
  Singleton<X3D::InfoReader>::removeInstance();
  Singleton<X3D::InfoReader>::removeInstance();
      
  return 1;
}
