#ifndef MESHMYMESHDATA_H
#define MESHMYMESHDATA_H

#include <X3DTK/MESH/scenegraph.h>

namespace X3DTK {
namespace MESH {

// My vertex data structure containing the weight information.

class VertexWeightData
{
public:
  void setWeight(const SFFloat &weight) {_weight = weight;};
  inline const SFFloat &getWeight() const {return _weight;};
  
private:
  SFFloat _weight;  
};

// My Mesh data aggregates.
#ifdef TEMPLATE_SPECIALIZATION_SUPPORTED

typedef clist<tlist<VertexPointData, tlist<VertexNormalData, tlist<VertexWeightData> > > > MyVertexData;
typedef clist<tlist<FaceNormalData> > MyFaceData;
typedef clist<tlist<MeshNormalData> > MyMeshData;

#else

class MyVertexData : public VertexData, public VertexWeightData {};
class MyFaceData : public FaceData {};
class MyMeshData : public MeshData {};

#endif

}
}

#endif
