namespace X3DTK {
namespace X3D {

template<class MData, class VData, class EData, class FData, bool RW>
MyMeshBuilderRenderingVisitor<MData, VData, EData, FData, RW>::MyMeshBuilderRenderingVisitor()
: TemplateMeshBuilderRenderingVisitor<MData, VData, EData, FData, RW>()
{
  define(Recorder<MyCoordinate>::getEnterFunction(&MyMeshBuilderRenderingVisitor::enterMyCoordinate));
}

template<class MData, class VData, class EData, class FData, bool RW>
void MyMeshBuilderRenderingVisitor<MData, VData, EData, FData, RW>::enterMyCoordinate(MyCoordinate *C)
{
  TemplateMeshBuilderStateVariables<MData, VData, EData, FData, RW> *stateVariables = Singleton<TemplateMeshBuilderStateVariables<MData, VData, EData, FData, RW> >::getInstance();
  
  MESH::TemplateVertex<MData, VData, EData, FData, RW> *MC = dynamic_cast<MESH::TemplateVertex<MData, VData, EData, FData, RW> *>(stateVariables->getNode(C));
  if (MC != 0)
  {
    // Filling the Vertices.
    const MFFloat &weight = C->getWeight();
    
    const typename MESH::TemplateVertex<MData, VData, EData, FData, RW>::MFVertex &vertices = MC->getVertices();
    
    // Test the optional presence of MESH::VertexPointData in VData.
    #ifdef TEMPLATE_SPECIALIZATION_SUPPORTED
    if (VData::template find<MESH::VertexWeightData>() && weight.size() >= vertices.size())
    #endif
    {
      MFFloat::const_iterator w = weight.begin();
      
      // Accessing the MESH::VertexWeightData of VData.
      for (typename MESH::TemplateVertex<MData, VData, EData, FData, RW>::MFVertex::const_iterator v = vertices.begin(); v != vertices.end(); ++v)
      {
        #ifdef TEMPLATE_SPECIALIZATION_SUPPORTED
        (*v)->template ogetData<MESH::VertexWeightData>().setWeight(*w);
        #else
        (*v)->data().setWeight(*w);
        #endif
        ++w;  
      }  
    }
    
    stateVariables->addCoupleNode(C, MC);  
  }
  stateVariables->pushNode(MC);
}

}
}
