namespace X3DTK {
namespace MESH {

template<class MData, class VData, class EData, class FData, bool RW>
TransformComputer<MData, VData, EData, FData, RW>::TransformComputer()
{
  setGraphTraversal(new DFSGraphTraversal());
  getGraphTraversal()->setComponentVisitor(new TransformComputerCoreVisitor<MData, VData, EData, FData, RW>());
}

template<class MData, class VData, class EData, class FData, bool RW>
TransformComputer<MData, VData, EData, FData, RW>::~TransformComputer()
{
  Singleton<TransformComputerStateVariables<MData, VData, EData, FData, RW> >::removeInstance();  
}

template<class MData, class VData, class EData, class FData, bool RW>
void TransformComputer<MData, VData, EData, FData, RW>::print(SFNode N)
{
  // Testing the presence of MESH::VertexPointData
  #ifdef TEMPLATE_SPECIALIZATION_SUPPORTED
  if (VData::template find<MESH::VertexPointData>())
  #endif
  {
    Singleton<TransformComputerStateVariables<MData, VData, EData, FData, RW> >::getInstance()->init();
    traverse(N);
    Singleton<TransformComputerStateVariables<MData, VData, EData, FData, RW> >::getInstance()->finish();
  }  
}

}
}

