#ifndef MESHTRANSFORMCOMPUTERGLOBALVARIABLES_H
#define MESHTRANSFORMCOMPUTERGLOBALVARIABLES_H

#include <X3DTK/kernel.h>

#include <list>

namespace X3DTK {
namespace MESH {

// State variables for the MeshTransformComputer processor.

template<class MData, class VData, class EData, class FData, bool readOnly>
class TransformComputerStateVariables : public StateVariables
{
public:
  TransformComputerStateVariables();

  void init();
  void finish();

  void pushMatrix(const SFMatrix34f &transformation);  
  void popMatrix();
  
  SFMatrix34f getMatrix() const {return _matrixStack.front();};

private: 
  std::list<SFMatrix34f> _matrixStack;
};

}
}

#include "MESH_TransformComputerStateVariables.inl"

#endif
