namespace X3DTK {
namespace MESH {

template<class MData, class VData, class EData, class FData, bool RW>
TransformComputerStateVariables<MData, VData, EData, FData, RW>::TransformComputerStateVariables()
: StateVariables()
{
}

template<class MData, class VData, class EData, class FData, bool RW>
void TransformComputerStateVariables<MData, VData, EData, FData, RW>::init()
{
  _matrixStack.push_front(SFMatrix34f::identity);
}

template<class MData, class VData, class EData, class FData, bool RW>
void TransformComputerStateVariables<MData, VData, EData, FData, RW>::finish()
{
  _matrixStack.clear();
}

template<class MData, class VData, class EData, class FData, bool RW>
void TransformComputerStateVariables<MData, VData, EData, FData, RW>::pushMatrix(const SFMatrix34f &transformation)
{
  _matrixStack.push_front(_matrixStack.front()*transformation);
}

template<class MData, class VData, class EData, class FData, bool RW>
void TransformComputerStateVariables<MData, VData, EData, FData, RW>::popMatrix()
{
  _matrixStack.pop_front();
}

}
}
