#ifndef VIEWER_H
#define VIEWER_H

#include <QGLViewer/qglviewer.h>
#include "SimpleMeshGLScene.h"

// Viewer for the meshViewer.

class Viewer : public QGLViewer
{
public:
  Viewer();
  ~Viewer();
  
protected :
  void loadFile();
  void keyPressEvent(QKeyEvent *e);
  void init();
  void draw();
  void about();
  QString helpString() const;
  void select(const QMouseEvent *e);
  void help() const;
  
private:
  X3DTK::SimpleMeshGLScene scene;
  
  // Events dispatched to the scene.
  inline void toggleDrawPoints() {scene.changeDrawPoints();};
  inline void toggleDrawEdges() {scene.changeDrawEdges();};
  inline void toggleDrawFaces() {scene.changeDrawFaces();};
  inline void toggleOneColorPerMesh() {scene.changeOneColorPerMesh();};

};

#endif
