#include "MyMemReleaser.h"
#include "MyMemReleaserAbstractVisitor.h"
#include "MyMemReleaserStateVariables.h"

#include <iostream>

using namespace std;

namespace X3DTK {

MyMemReleaser::MyMemReleaser()
: MemReleaser()
{
  // Sets the Abstract visitor for MyMemReleaser processor. 
  setComponentVisitor(new MyMemReleaserAbstractVisitor());
}

void MyMemReleaser::release(SFNode N, bool verbose)
{
  // initializing the state variables.
  Singleton<MyMemReleaserStateVariables>::getInstance()->init();
  
  // call to super-class method.
  MemReleaser::release(N, verbose);
  
  // print the number of nodes.
  cout << endl << Singleton<MyMemReleaserStateVariables>::getInstance()->getNodeNumber() << " nodes visited" << endl;
}

}
