#include "MyMemReleaser.h"

#include <X3DTK/X3D/scenegraph.h>
#include <iostream>

using namespace X3DTK;
using namespace std;

int main(int argc, char *argv[])
{
  if (argc <= 1)
  {
    cerr << "usage: mymemreleaser input" << endl;
    exit(0);
  }
 
  // Default loader for the X3D Nodes.
  X3D::Loader *loader = Singleton<X3D::Loader>::getInstance();
  // Instanciation of GraphTester.
  MemReleaser *releaser = Singleton<MyMemReleaser>::getInstance();
  
  // Loads the scene.
  X3D::Scene *s = loader->load(argv[1]);
  // Releases the memory.
  releaser->release(s);
  
  // removes the instance.
  Singleton<MyMemReleaser>::removeInstance();
  Singleton<X3D::Loader>::removeInstance();  
  
  return 1;
}
