#include "MESH_MyStructureComputer.h"
#include "MESH_MyStructureComputerCoreVisitor.h"

namespace X3DTK {
namespace MESH {

MyStructureComputer::MyStructureComputer()
{
  setGraphTraversal(new DFSGraphTraversal());
  setComponentVisitor(new MyStructureComputerCoreVisitor());
}

MyStructureComputer::~MyStructureComputer()
{
  Singleton<MyStructureComputerStateVariables>::removeInstance();
}

MySimpleMesh *MyStructureComputer::compute(SFNode N)
{
  Singleton<MyStructureComputerStateVariables>::getInstance()->init();
  traverse(N);
  Singleton<MyStructureComputerStateVariables>::getInstance()->finish();
  
  return Singleton<MyStructureComputerStateVariables>::getInstance()->getMesh();
}

}
}

