#ifndef MYSIMPLEMESH_H
#define MYSIMPLEMESH_H

#include <vector>
#include <list>

struct MyVertex
{
  float x;
  float y;
  float z;
};

typedef std::list<unsigned int> MyFace;

// MySimpleMesh class.

class MySimpleMesh
{
public:
  MySimpleMesh();
  ~MySimpleMesh();
  
  void addVertex(float x, float y, float z);
  void addFace(const std::list<unsigned int> &indexes);
  void print() const;
  
  inline std::vector<MyVertex> &getVertexArray() {return _vertexArray;};
  inline std::vector<MyFace> &getIndexArray() {return _indexArray;};
  
private:
  std::vector<MyVertex> _vertexArray;
  std::vector<MyFace> _indexArray;
};

#endif
