#include "MESH_MyStructureComputer.h"

#include <X3DTK/X3D/scenegraph.h>
#include <X3DTK/X3D/meshbuilder.h>
#include <X3DTK/memreleaser.h>

#include <iostream>
#include <X3DTK/graphtester.h>

using namespace X3DTK;
using namespace std;

int main(int argc, char *argv[])
{
  if (argc <= 1)
  {
    cerr << "usage: MyStructureComputer input" << endl;
    exit(0);
  }
  
  // DefaultLoader to load the default X3D Nodes.
  X3D::Loader *loader = Singleton<X3D::Loader>::getInstance();
  // Instanciation of the new MeshBuilder.
  X3D::MeshBuilder *meshbuilder = Singleton<X3D::MeshBuilder>::getInstance();
  // Instanciation of the new MyStructureComputer.
  MESH::MyStructureComputer *msc = Singleton<MESH::MyStructureComputer>::getInstance();  
  
  // Loads the scene.
  X3D::Scene *s = loader->load(argv[1], false);
  MESH::Scene *ms = meshbuilder->build(s);
  MySimpleMesh *mesh = msc->compute(ms);  
 
  GraphTester *gt = Singleton<GraphTester>::getInstance();
  gt->test(ms);
 
  // prints the content.
  mesh->print();
  
  // removes all the instances.
  Singleton<X3D::MeshBuilder>::removeInstance();
  Singleton<MESH::MyStructureComputer>::removeInstance();
  
  Singleton<X3D::Loader>::removeInstance();
  
  return 1;
}
