#include "X3D_NodeCounter.h"
#include "X3D_NodeCounterRenderingVisitor.h"
#include "X3D_NodeCounterGroupingVisitor.h"
#include "X3D_NodeCounterCoreVisitor.h"
#include "X3D_NodeCounterStateVariables.h"
#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

NodeCounter::NodeCounter()
: X3DOnePassProcessor()
{
  setGraphTraversal(new DFSGraphTraversal());
  setComponentVisitor(new NodeCounterRenderingVisitor());
  setComponentVisitor(new NodeCounterGroupingVisitor());
  setComponentVisitor(new NodeCounterCoreVisitor());
}

NodeCounter::~NodeCounter()
{
  Singleton<NodeCounterStateVariables>::removeInstance();
}
  
void NodeCounter::count(X3DNode *N)
{
  Singleton<NodeCounterStateVariables>::getInstance()->init();
  traverse(N);
  cout << "number of geometry nodes is " << Singleton<NodeCounterStateVariables>::getInstance()->getX3DGeometryNode() << endl;
  cout << "number of coordinate nodes is " << Singleton<NodeCounterStateVariables>::getInstance()->getX3DCoordinateNode() << endl;
  cout << "number of grouping nodes is " << Singleton<NodeCounterStateVariables>::getInstance()->getX3DGroupingNode() << endl;
  cout << "number of visited nodes is " << Singleton<NodeCounterStateVariables>::getInstance()->getOtherNode() 
                                 + Singleton<NodeCounterStateVariables>::getInstance()->getX3DGeometryNode() 
                                 + Singleton<NodeCounterStateVariables>::getInstance()->getX3DCoordinateNode() 
                                 + Singleton<NodeCounterStateVariables>::getInstance()->getX3DGroupingNode() << endl;
}
  
}
}  
