#include "X3D_NodeCounterRenderingVisitor.h"
#include "X3D_NodeCounterStateVariables.h"

namespace X3DTK {
namespace X3D {

NodeCounterRenderingVisitor::NodeCounterRenderingVisitor()
: RenderingVisitor()
{
  define(Recorder<X3DGeometryNode>::getEnterFunction(&NodeCounterRenderingVisitor::enterX3DGeometryNode));
  define(Recorder<X3DGeometryNode>::getWalkOnFunction(&NodeCounterRenderingVisitor::walkOnX3DGeometryNode));
  define(Recorder<X3DCoordinateNode>::getEnterFunction(&NodeCounterRenderingVisitor::enterX3DCoordinateNode));
}
  
void NodeCounterRenderingVisitor::enterX3DGeometryNode(X3DGeometryNode *N)
{
  Singleton<NodeCounterStateVariables>::getInstance()->addX3DGeometryNode();
}

bool NodeCounterRenderingVisitor::walkOnX3DGeometryNode(X3DGeometryNode *N, X3DAbstractNode *child)
{
  return (dynamic_cast<X3DCoordinateNode *>(child) != 0);
}

void NodeCounterRenderingVisitor::enterX3DCoordinateNode(X3DCoordinateNode *N)
{
  Singleton<NodeCounterStateVariables>::getInstance()->addX3DCoordinateNode();
}

}
}
