#ifndef X3D_NODECOUNTERSTATEVARIABLES_H
#define X3D_NODECOUNTERSTATEVARIABLES_H

#include <X3DTK/kernel.h>

namespace X3DTK {
namespace X3D {

class NodeCounterStateVariables : public StateVariables
{
public:
  NodeCounterStateVariables();
  
  void init();
  
  void addX3DGeometryNode();
  void addX3DCoordinateNode();
  void addX3DGroupingNode();
  void addOtherNode();
  
  inline unsigned int getX3DGeometryNode() const {return _geometryCount;};
  inline unsigned int getX3DCoordinateNode() const {return _coordinateCount;};
  inline unsigned int getX3DGroupingNode() const {return _groupingCount;};
  inline unsigned int getOtherNode() const {return _otherCount;};
  
private:
  unsigned int _geometryCount;
  unsigned int _coordinateCount;
  unsigned int _groupingCount;
  unsigned int _otherCount;  
};

}
}

#endif
