#include "X3D_NodeCounter.h"

#include <X3DTK/X3D/scenegraph.h>
#include <iostream>

using namespace X3DTK;
using namespace std;

int main(int argc, char *argv[])
{
  if (argc <= 1)
  {
    cerr << "usage: nodecounter input" << endl;
    exit(0);
  }
  
  // DefaultLoader to load the default X3D Nodes.
  X3D::Loader *loader = Singleton<X3D::Loader>::getInstance();
  // Instanciation of MyMemReleaser.
  X3D::NodeCounter *counter = Singleton<X3D::NodeCounter>::getInstance();
  
  // Loads the scene.
  X3D::Scene *s = loader->load(argv[1]);
  // Releases the memory.
  counter->count(s);
  
  // removes the instance.
  Singleton<X3D::NodeCounter>::removeInstance();
  Singleton<X3D::Loader>::removeInstance();  
  
  return 1;
}
