CONFIG *= thread
CONFIG -= qt

# needs to be added if the library uses Qt xml parser. Can be removed if not.
macx: QMAKE_LFLAGS += -lqt

contains(HELP, yes) {
  message("options:")
  message("X3DTK_DIR: X3DTK installation directory")
  message("X3DTK_LIB_DIR: X3DTK library binary directory")
  message("X3DTK_INC_DIR: X3DTK include files directory")
}

!isEmpty(X3DTK_DIR) {
  INCLUDEPATH *= $$X3DTK_DIR/include
} else {
  !isEmpty(X3DTK_INC_DIR) {
    INCLUDEPATH *= $$X3DTK_INC_DIR
  } else {
    INCLUDEPATH *= ../../include
  }
}  
  

!isEmpty(X3DTK_LIB_DIR) {
  win32 {
    LIBS *= X3DTK100.lib
  } else {
    LIBS *= -L$$X3DTK_LIB_DIR -lX3DTK
  }  
} else {
  !isEmpty(X3DTK_DIR) {
    win32 {
      LIBS *= X3DTK100.lib
    } else {
      LIBS *= -L$$X3DTK_DIR/lib -lX3DTK 
    }
  } else {
    win32 {
      LIBS *= X3DTK100.lib
    } else {
      LIBS *= -L../../lib -lX3DTK 
    }
  } 
}

win32:CONFIG += console rtti


TARGET = nodecounter

HEADERS = X3D_NodeCounter.h \
          X3D_NodeCounterStateVariables.h \
          X3D_NodeCounterRenderingVisitor.h \
          X3D_NodeCounterGroupingVisitor.h \
          X3D_NodeCounterCoreVisitor.h

SOURCES = X3D_NodeCounter.cpp \
          X3D_NodeCounterStateVariables.cpp \
          X3D_NodeCounterRenderingVisitor.cpp \
          X3D_NodeCounterGroupingVisitor.cpp \          
          X3D_NodeCounterCoreVisitor.cpp \
          main.cpp
