#include <X3DTK/X3D/scenegraph.h>
#include <X3DTK/graphtester.h>
#include <X3DTK/memreleaser.h>
#include "X3D_MyGroupingCreator.h"
#include "X3D_MyComponentCreator.h"

#include <iostream>

using namespace X3DTK;
using namespace std;

int main(int argc, char *argv[])
{
  if (argc <= 1)
  {
    cerr << "usage: redefineNodeTester input" << endl;
    exit(0);
  }
  
  X3D::Loader *loader = Singleton<X3D::Loader>::getInstance();
  loader->setComponentCreator(new X3D::MyGroupingCreator());
  MemReleaser *releaser = Singleton<MemReleaser>::getInstance();
  GraphTester *graphtester = Singleton<GraphTester>::getInstance();
  
  // Loads the scene.
  X3D::Scene *s = loader->load(argv[1], false);
  graphtester->test(s);
 
  // Releases the scene.
  releaser->release(s);
  // adding new component creator.
  loader->setComponentCreator(new X3D::MyComponentCreator());

  cout << "***Check x3dtk.log to see that Shape cannot have an Info child!***" << endl;
  
  // Loads the scene.
  s = loader->load(argv[1], false);
  graphtester->test(s);
   
  return 1;
}
