#include "GL_SimpleAnimator.h"
#include "GL_SimpleAnimatorGeometry3DVisitor.h"

namespace X3DTK {
namespace GL {

SimpleAnimator::SimpleAnimator()
: X3DOnePassProcessor()
{
  setGraphTraversal(new DFSGraphTraversal());
  setComponentVisitor(new SimpleAnimatorGeometry3DVisitor());
}

SimpleAnimator::~SimpleAnimator()
{
  Singleton<SimpleAnimatorStateVariables>::removeInstance();
}

void SimpleAnimator::setBBoxSize(const SFVec3f &size)
{
  Singleton<SimpleAnimatorStateVariables>::getInstance()->setBBoxSize(size);
}

void SimpleAnimator::animate(SFNode N, float time)
{
  // Setting the time.
  Singleton<SimpleAnimatorStateVariables>::getInstance()->setTime(time);
  getGraphTraversal()->traverse(N);
}

}
}
