#ifndef VIEWER_H
#define VIEWER_H

#include <QGLViewer/qglviewer.h>
#include <X3DTK/simplifiedmeshscene.h>

#include "BasicDrawer.h"

typedef enum {VERTEX, EDGE, FACE} Entity;

// Viewer for the meshViewer.

class Viewer : public QGLViewer
{
public:
  Viewer();
  
protected :
  void loadFile();
  void keyPressEvent(QKeyEvent *e);
  void init();
  void draw();
  QString helpString() const;
  void help() const;
  
private:
  X3DTK::SimplifiedMeshScene scene;
  X3DTK::MESH::BasicDrawer drawer;
  Entity entity;
};

#endif
